package gregapi.block.multitileentity;

import static gregapi.data.CS.W;
import static net.minecraftforge.common.util.ForgeDirection.UP;
import gregapi.block.IBlockMaterial;
import gregapi.block.IBlockRetrievable;
import gregapi.block.IBlockToolable;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityAddCollisionBoxesToList;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityAddDestroyEffects;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityAddHitEffects;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityBeginLeavesDecay;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityBreakBlock;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityCanBeReplacedByLeaves;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityCanBlockStay;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityCanConnectRedstone;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityCanCreatureSpawn;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityCanEntityDestroy;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityCanPlaceTorchOnTop;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityCanSustainLeaves;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityCanSustainPlant;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityCollisionRayTrace;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityDropXpOnBlockBreak;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityFillWithRain;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityGetBedDirection;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityGetBedSpawnPosition;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityGetBlockHardness;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityGetBlocksMovement;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityGetCollisionBoundingBoxFromPool;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityGetComparatorInputOverride;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityGetDrops;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityGetEnchantPowerBonus;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityGetExplosionResistance;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityGetFireSpreadSpeed;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityGetFlammability;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityGetLightOpacity;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityGetLightValue;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityGetMaterialAtSide;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityGetMixedBrightnessForBlock;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityGetPickBlock;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityGetSelectedBoundingBoxFromPool;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityGetStackFromBlock;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityGetValidRotations;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityGetWeakChanges;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityIsAir;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityIsBeaconBase;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityIsBed;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityIsBedFoot;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityIsBlockSolid;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityIsBurning;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityIsFertile;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityIsFireSource;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityIsFoliage;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityIsLadder;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityIsLeaves;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityIsNormalCube;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityIsProvidingStrongPower;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityIsProvidingWeakPower;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityIsReplaceable;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityIsReplaceableOreGen;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityIsSideSolid;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityIsWood;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityOnBlockActivated;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityOnBlockAdded;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityOnBlockClicked;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityOnBlockDestroyedByExplosion;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityOnBlockDestroyedByPlayer;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityOnBlockExploded;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityOnBlockHarvested;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityOnBlockPreDestroy;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityOnEntityCollidedWithBlock;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityOnEntityWalking;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityOnFallenUpon;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityOnPlantGrow;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityOnToolClick;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityRandomDisplayTick;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityRecolourBlock;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityRemoveMaterialFromSide;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityRemovedByPlayer;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityRotateBlock;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntitySetBedOccupied;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntitySetBlockBoundsBasedOnState;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityShouldCheckWeakPower;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityShouldSideBeRendered;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityUpdateTick;
import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityVelocityToAddToEntity;
import gregapi.code.ArrayListNoNulls;
import gregapi.oredict.OreDictMaterialStack;
import gregapi.render.IRenderedBlock;
import gregapi.render.IRenderedBlockObject;
import gregapi.render.ITexture;
import gregapi.render.RendererBlockTextured;
import gregapi.tileentity.ITileEntity;
import gregapi.util.UT;

import java.util.*;

import net.minecraft.block.Block;
import net.minecraft.block.ITileEntityProvider;
import net.minecraft.block.material.Material;
import net.minecraft.client.particle.EffectRenderer;
import net.minecraft.client.renderer.texture.IIconRegister;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.enchantment.EnchantmentHelper;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.EnumCreatureType;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.Item;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.stats.StatList;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.*;
import net.minecraft.world.Explosion;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.common.IPlantable;
import net.minecraftforge.common.util.ForgeDirection;
import net.minecraftforge.event.ForgeEventFactory;
import cpw.mods.fml.common.registry.GameRegistry;

/**
 * @author Gregorius Techneticies
 */
public class MultiTileEntityBlock extends Block implements IRenderedBlock, ITileEntityProvider, IBlockToolable, IBlockRetrievable, IBlockMaterial {
	/** There are quite some odd timings in the Block breaking Code which require the TileEntity to be buffered. */
	public static ThreadLocal<TileEntity> sTemporaryTileEntity = new ThreadLocal<TileEntity>();
	
	private final int mHarvestLevelOffset, mHarvestLevelMinimum, mHarvestLevelMaximum;
	private final String mNameInternal, mTool;
	private final boolean mOpaque, mNormalCube;
	
	private static final Map<String, MultiTileEntityBlock> MULTITILEENTITYBLOCKMAP = new HashMap<String, MultiTileEntityBlock>();
	
	public static String getName(String aNameOfVanillaMaterialField, Material aVanillaMaterial, SoundType aSoundType, String aTool, int aHarvestLevelOffset, int aHarvestLevelMinimum, int aHarvestLevelMaximum, boolean aOpaque, boolean aNormalCube) {
		return "gt.block.multitileentity." + aNameOfVanillaMaterialField + "." + aSoundType.soundName + "." + aTool + "." + aHarvestLevelOffset + "." + aHarvestLevelMinimum + "." + aHarvestLevelMaximum + "." + aOpaque + "." + aNormalCube;
	}
	
	public static MultiTileEntityBlock getOrCreate(String aNameOfVanillaMaterialField, Material aVanillaMaterial, SoundType aSoundType, String aTool, int aHarvestLevelOffset, int aHarvestLevelMinimum, int aHarvestLevelMaximum, boolean aOpaque, boolean aNormalCube) {
		MultiTileEntityBlock rBlock = MULTITILEENTITYBLOCKMAP.get(getName(aNameOfVanillaMaterialField, aVanillaMaterial, aSoundType, aTool = aTool.toLowerCase(), aHarvestLevelOffset, aHarvestLevelMinimum, aHarvestLevelMaximum, aOpaque, aNormalCube));
		return rBlock == null ? new MultiTileEntityBlock(aNameOfVanillaMaterialField, aVanillaMaterial, aSoundType, aTool, aHarvestLevelOffset, aHarvestLevelMinimum, aHarvestLevelMaximum, aOpaque, aNormalCube) : rBlock;
	}
	
	/**
	 * @param aNameOfVanillaMaterialField the Name of the vanilla Material Field. In case this is not a vanilla Material, insert the Name you want to give your own Material instead.
	 * @param aVanillaMaterial the Material used to determine the Block.
	 * @param aSoundType the Sound Type of the Block.
	 * @param aTool the Tool used to harvest this Block.
	 * @param aHarvestLevelOffset
	 * @param aHarvestLevelMinimum
	 * @param aHarvestLevelMaximum
	 * @param aOpaque if this Block is Opaque.
	 * @param aNormalCube if this Block is a normal Cube (for Redstone Stuff).
	 */
	private MultiTileEntityBlock(String aNameOfVanillaMaterialField, Material aVanillaMaterial, SoundType aSoundType, String aTool, int aHarvestLevelOffset, int aHarvestLevelMinimum, int aHarvestLevelMaximum, boolean aOpaque, boolean aNormalCube) {
		super(aVanillaMaterial);
		mNameInternal = getName(aNameOfVanillaMaterialField, aVanillaMaterial, aSoundType, aTool, aHarvestLevelOffset, aHarvestLevelMinimum, aHarvestLevelMaximum, aOpaque, aNormalCube);
		GameRegistry.registerBlock(this, ItemBlock.class, mNameInternal);
		MULTITILEENTITYBLOCKMAP.put(mNameInternal, this);
		
		setStepSound(aSoundType);
		mOpaque = aOpaque;
		mNormalCube = aNormalCube;
		
		mTool = aTool.toLowerCase();
		mHarvestLevelOffset = aHarvestLevelOffset;
		mHarvestLevelMinimum = Math.max(0, aHarvestLevelMinimum);
		mHarvestLevelMaximum = Math.max(aHarvestLevelMinimum, aHarvestLevelMaximum);
		
        opaque = this.isOpaqueCube();
        lightOpacity = this.isOpaqueCube() ? 255 : 0;
        
        try {codechicken.nei.api.API.hideItem(new ItemStack(this, 1, W));} catch(Throwable e) {/**/}
	}
	
	private static boolean LOCK = false;
	
    // You want to override one of those Functions with your TileEntity? Just implement the Interfaces of MultiTileEntityInterfaces on your TileEntity and you are done.
	@Override public final boolean getBlocksMovement(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityGetBlocksMovement ? ((IMultiTileEntityGetBlocksMovement)aTileEntity).getBlocksMovement() : super.getBlocksMovement(aWorld, aX, aY, aZ);}
    @Override public final boolean isBlockSolid(IBlockAccess aWorld, int aX, int aY, int aZ, int aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityIsBlockSolid ? ((IMultiTileEntityIsBlockSolid)aTileEntity).isBlockSolid((byte)aSide) : super.isBlockSolid(aWorld, aX, aY, aZ, aSide);}
    @Override public final void addCollisionBoxesToList(World aWorld, int aX, int aY, int aZ, AxisAlignedBB aAABB, List aList, Entity aEntity) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMultiTileEntityAddCollisionBoxesToList) ((IMultiTileEntityAddCollisionBoxesToList)aTileEntity).addCollisionBoxesToList(aAABB, aList, aEntity); else super.addCollisionBoxesToList(aWorld, aX, aY, aZ, aAABB, aList, aEntity);}
    @Override public final AxisAlignedBB getCollisionBoundingBoxFromPool(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityGetCollisionBoundingBoxFromPool ? ((IMultiTileEntityGetCollisionBoundingBoxFromPool)aTileEntity).getCollisionBoundingBoxFromPool() : super.getCollisionBoundingBoxFromPool(aWorld, aX, aY, aZ);}
    @Override public final void updateTick(World aWorld, int aX, int aY, int aZ, Random aRandom) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMultiTileEntityUpdateTick) ((IMultiTileEntityUpdateTick)aTileEntity).updateTick(aRandom); else super.updateTick(aWorld, aX, aY, aZ, aRandom);}
    @Override public final void onBlockDestroyedByPlayer(World aWorld, int aX, int aY, int aZ, int aRandom) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity == null) aTileEntity = sTemporaryTileEntity.get(); if (aTileEntity instanceof IMultiTileEntityOnBlockDestroyedByPlayer) ((IMultiTileEntityOnBlockDestroyedByPlayer)aTileEntity).onBlockDestroyedByPlayer(aRandom); else super.onBlockDestroyedByPlayer(aWorld, aX, aY, aZ, aRandom);}
    @Override public final void onBlockAdded(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMultiTileEntityOnBlockAdded) ((IMultiTileEntityOnBlockAdded)aTileEntity).onBlockAdded(); else super.onBlockAdded(aWorld, aX, aY, aZ);}
    @Override public final void dropXpOnBlockBreak(World aWorld, int aX, int aY, int aZ, int aXP) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMultiTileEntityDropXpOnBlockBreak) ((IMultiTileEntityDropXpOnBlockBreak)aTileEntity).dropXpOnBlockBreak(aXP); else super.dropXpOnBlockBreak(aWorld, aX, aY, aZ, aXP);}
    @Override public final MovingObjectPosition collisionRayTrace(World aWorld, int aX, int aY, int aZ, Vec3 aVectorA, Vec3 aVectorB) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityCollisionRayTrace ? ((IMultiTileEntityCollisionRayTrace)aTileEntity).collisionRayTrace(aVectorA, aVectorB) : super.collisionRayTrace(aWorld, aX, aY, aZ, aVectorA, aVectorB);}
    @Override public final void onBlockDestroyedByExplosion(World aWorld, int aX, int aY, int aZ, Explosion aExplosion) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMultiTileEntityOnBlockDestroyedByExplosion) ((IMultiTileEntityOnBlockDestroyedByExplosion)aTileEntity).onBlockDestroyedByExplosion(aExplosion); else super.onBlockDestroyedByExplosion(aWorld, aX, aY, aZ, aExplosion);}
    @Override public final boolean onBlockActivated(World aWorld, int aX, int aY, int aZ, EntityPlayer aPlayer, int aSide, float aHitX, float aHitY, float aHitZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityOnBlockActivated ? ((IMultiTileEntityOnBlockActivated)aTileEntity).onBlockActivated(aPlayer, (byte)aSide, aHitX, aHitY, aHitZ) : super.onBlockActivated(aWorld, aX, aY, aZ, aPlayer, aSide, aHitX, aHitY, aHitZ);}
    @Override public final void onEntityWalking(World aWorld, int aX, int aY, int aZ, Entity aEntity) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMultiTileEntityOnEntityWalking) ((IMultiTileEntityOnEntityWalking)aTileEntity).onEntityWalking(aEntity); else super.onEntityWalking(aWorld, aX, aY, aZ, aEntity);}
    @Override public final void onBlockClicked(World aWorld, int aX, int aY, int aZ, EntityPlayer aPlayer) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMultiTileEntityOnBlockClicked) ((IMultiTileEntityOnBlockClicked)aTileEntity).onBlockClicked(aPlayer); else super.onBlockClicked(aWorld, aX, aY, aZ, aPlayer);}
    @Override public final void velocityToAddToEntity(World aWorld, int aX, int aY, int aZ, Entity aEntity, Vec3 aVector) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMultiTileEntityVelocityToAddToEntity) ((IMultiTileEntityVelocityToAddToEntity)aTileEntity).velocityToAddToEntity(aEntity, aVector); else super.velocityToAddToEntity(aWorld, aX, aY, aZ, aEntity, aVector);}
    @Override public final void setBlockBoundsBasedOnState(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMultiTileEntitySetBlockBoundsBasedOnState) ((IMultiTileEntitySetBlockBoundsBasedOnState)aTileEntity).setBlockBoundsBasedOnState(); else super.setBlockBoundsBasedOnState(aWorld, aX, aY, aZ);}
    @Override public final int isProvidingWeakPower(IBlockAccess aWorld, int aX, int aY, int aZ, int aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityIsProvidingWeakPower ? ((IMultiTileEntityIsProvidingWeakPower)aTileEntity).isProvidingWeakPower((byte)aSide) : super.isProvidingWeakPower(aWorld, aX, aY, aZ, aSide);}
    @Override public final void onEntityCollidedWithBlock(World aWorld, int aX, int aY, int aZ, Entity aEntity) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMultiTileEntityOnEntityCollidedWithBlock) ((IMultiTileEntityOnEntityCollidedWithBlock)aTileEntity).onEntityCollidedWithBlock(aEntity); else super.onEntityCollidedWithBlock(aWorld, aX, aY, aZ, aEntity);}
    @Override public final int isProvidingStrongPower(IBlockAccess aWorld, int aX, int aY, int aZ, int aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityIsProvidingStrongPower ? ((IMultiTileEntityIsProvidingStrongPower)aTileEntity).isProvidingStrongPower((byte)aSide) : super.isProvidingStrongPower(aWorld, aX, aY, aZ, aSide);}
    @Override public final boolean canBlockStay(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityCanBlockStay ? ((IMultiTileEntityCanBlockStay)aTileEntity).canBlockStay() : true;}
    @Override public final void onFallenUpon(World aWorld, int aX, int aY, int aZ, Entity aEntity, float aFallDistance) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMultiTileEntityOnFallenUpon) ((IMultiTileEntityOnFallenUpon)aTileEntity).onFallenUpon(aEntity, aFallDistance); else super.onFallenUpon(aWorld, aX, aY, aZ, aEntity, aFallDistance);}
    @Override public final void onBlockHarvested(World aWorld, int aX, int aY, int aZ, int aMetaData, EntityPlayer aPlayer) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMultiTileEntityOnBlockHarvested) ((IMultiTileEntityOnBlockHarvested)aTileEntity).onBlockHarvested(aMetaData, aPlayer); else super.onBlockHarvested(aWorld, aX, aY, aZ, aMetaData, aPlayer);}
    @Override public final void onBlockPreDestroy(World aWorld, int aX, int aY, int aZ, int aMetaData) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMultiTileEntityOnBlockPreDestroy) ((IMultiTileEntityOnBlockPreDestroy)aTileEntity).onBlockPreDestroy(aMetaData); else super.onBlockPreDestroy(aWorld, aX, aY, aZ, aMetaData);}
    @Override public final void fillWithRain(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMultiTileEntityFillWithRain) ((IMultiTileEntityFillWithRain)aTileEntity).fillWithRain(); else super.fillWithRain(aWorld, aX, aY, aZ);}
    @Override public final int getComparatorInputOverride(World aWorld, int aX, int aY, int aZ, int aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityGetComparatorInputOverride ? ((IMultiTileEntityGetComparatorInputOverride)aTileEntity).getComparatorInputOverride((byte)aSide) : super.getComparatorInputOverride(aWorld, aX, aY, aZ, aSide);}
    @Override public final int getLightValue(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityGetLightValue ? ((IMultiTileEntityGetLightValue)aTileEntity).getLightValue() : super.getLightValue(aWorld, aX, aY, aZ);}
    @Override public final boolean isLadder(IBlockAccess aWorld, int aX, int aY, int aZ, EntityLivingBase aEntity) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityIsLadder ? ((IMultiTileEntityIsLadder)aTileEntity).isLadder(aEntity) : super.isLadder(aWorld, aX, aY, aZ, aEntity);}
    @Override public final boolean isNormalCube(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityIsNormalCube ? ((IMultiTileEntityIsNormalCube)aTileEntity).isNormalCube() : mNormalCube;}
    @Override public final boolean isReplaceable(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityIsReplaceable ? ((IMultiTileEntityIsReplaceable)aTileEntity).isReplaceable() : blockMaterial.isReplaceable();}
    @Override public final boolean isBurning(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityIsBurning ? ((IMultiTileEntityIsBurning)aTileEntity).isBurning() : false;}
    @Override public final boolean isAir(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityIsAir ? ((IMultiTileEntityIsAir)aTileEntity).isAir() : super.isAir(aWorld, aX, aY, aZ);}
    @Override public final boolean removedByPlayer(World aWorld, EntityPlayer aPlayer, int aX, int aY, int aZ, boolean aWillHarvest) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); sTemporaryTileEntity.set(aTileEntity); return aTileEntity instanceof IMultiTileEntityRemovedByPlayer ? ((IMultiTileEntityRemovedByPlayer)aTileEntity).removedByPlayer(aWorld, aPlayer, aWillHarvest) : super.removedByPlayer(aWorld, aPlayer, aX, aY, aZ, aWillHarvest);}
    @Override public final boolean canCreatureSpawn(EnumCreatureType aType, IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityCanCreatureSpawn ? ((IMultiTileEntityCanCreatureSpawn)aTileEntity).canCreatureSpawn(aType) : isSideSolid(aWorld, aX, aY, aZ, UP);}
    @Override public final boolean isBed(IBlockAccess aWorld, int aX, int aY, int aZ, EntityLivingBase aPlayer) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityIsBed ? ((IMultiTileEntityIsBed)aTileEntity).isBed(aPlayer) : false;}
    @Override public final ChunkCoordinates getBedSpawnPosition(IBlockAccess aWorld, int aX, int aY, int aZ, EntityPlayer aPlayer) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityVelocityToAddToEntity ? ((IMultiTileEntityGetBedSpawnPosition)aTileEntity).getBedSpawnPosition(aPlayer) : null;}
    @Override public final void setBedOccupied(IBlockAccess aWorld, int aX, int aY, int aZ, EntityPlayer aPlayer, boolean aOccupied) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMultiTileEntitySetBedOccupied) ((IMultiTileEntitySetBedOccupied)aTileEntity).setBedOccupied(aPlayer, aOccupied);}
    @Override public final int getBedDirection(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityGetBedDirection ? ((IMultiTileEntityGetBedDirection)aTileEntity).getBedDirection() : 0;}
    @Override public final boolean isBedFoot(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityIsBedFoot ? ((IMultiTileEntityIsBedFoot)aTileEntity).isBedFoot() : false;}
    @Override public final void beginLeavesDecay(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMultiTileEntityBeginLeavesDecay) ((IMultiTileEntityBeginLeavesDecay)aTileEntity).beginLeavesDecay(); else super.beginLeavesDecay(aWorld, aX, aY, aZ);}
    @Override public final boolean canSustainLeaves(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityCanSustainLeaves ? ((IMultiTileEntityCanSustainLeaves)aTileEntity).canSustainLeaves() : super.canSustainLeaves(aWorld, aX, aY, aZ);}
    @Override public final boolean isLeaves(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityIsLeaves ? ((IMultiTileEntityIsLeaves)aTileEntity).isLeaves() : super.isLeaves(aWorld, aX, aY, aZ);}
    @Override public final boolean canBeReplacedByLeaves(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityCanBeReplacedByLeaves ? ((IMultiTileEntityCanBeReplacedByLeaves)aTileEntity).canBeReplacedByLeaves() : false;}
    @Override public final boolean isWood(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityIsWood ? ((IMultiTileEntityIsWood)aTileEntity).isWood() : super.isWood(aWorld, aX, aY, aZ);}
    @Override public final boolean isReplaceableOreGen(World aWorld, int aX, int aY, int aZ, Block aTarget) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityIsReplaceableOreGen ? ((IMultiTileEntityIsReplaceableOreGen)aTileEntity).isReplaceableOreGen(aTarget) : super.isReplaceableOreGen(aWorld, aX, aY, aZ, aTarget);}
    @Override public final boolean canConnectRedstone(IBlockAccess aWorld, int aX, int aY, int aZ, int aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityCanConnectRedstone ? ((IMultiTileEntityCanConnectRedstone)aTileEntity).canConnectRedstone((byte)aSide) : super.canConnectRedstone(aWorld, aX, aY, aZ, aSide);}
    @Override public final boolean canPlaceTorchOnTop(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityCanPlaceTorchOnTop ? ((IMultiTileEntityCanPlaceTorchOnTop)aTileEntity).canPlaceTorchOnTop() : isSideSolid(aWorld, aX, aY, aZ, UP);}
    @Override public final boolean isFoliage(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityIsFoliage ? ((IMultiTileEntityIsFoliage)aTileEntity).isFoliage() : super.isFoliage(aWorld, aX, aY, aZ);}
    @Override public final boolean canSustainPlant(IBlockAccess aWorld, int aX, int aY, int aZ, ForgeDirection aSide, IPlantable aPlantable) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityCanSustainPlant ? ((IMultiTileEntityCanSustainPlant)aTileEntity).canSustainPlant((byte)aSide.ordinal(), aPlantable) : super.canSustainPlant(aWorld, aX, aY, aZ, aSide, aPlantable);}
    @Override public final void onPlantGrow(World aWorld, int aX, int aY, int aZ, int sX, int sY, int sZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMultiTileEntityOnPlantGrow) ((IMultiTileEntityOnPlantGrow)aTileEntity).onPlantGrow(sX, sY, sZ); else super.onPlantGrow(aWorld, aX, aY, aZ, sX, sY, sZ);}
    @Override public final boolean isFertile(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityIsFertile ? ((IMultiTileEntityIsFertile)aTileEntity).isFertile() : false;}
    @Override public final boolean rotateBlock(World aWorld, int aX, int aY, int aZ, ForgeDirection aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityRotateBlock ? ((IMultiTileEntityRotateBlock)aTileEntity).rotateBlock((byte)aSide.ordinal()) : false;}
    @Override public final ForgeDirection[] getValidRotations(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityGetValidRotations ? ((IMultiTileEntityGetValidRotations)aTileEntity).getValidRotations() : new ForgeDirection[0];}
    @Override public final float getEnchantPowerBonus(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityGetEnchantPowerBonus ? ((IMultiTileEntityGetEnchantPowerBonus)aTileEntity).getEnchantPowerBonus() : 0;}
    @Override public final boolean recolourBlock(World aWorld, int aX, int aY, int aZ, ForgeDirection aSide, int aColor) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityRecolourBlock ? ((IMultiTileEntityRecolourBlock)aTileEntity).recolourBlock((byte)aSide.ordinal(), (byte)aColor) : false;}
    @Override public final boolean shouldCheckWeakPower(IBlockAccess aWorld, int aX, int aY, int aZ, int aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityShouldCheckWeakPower ? ((IMultiTileEntityShouldCheckWeakPower)aTileEntity).shouldCheckWeakPower((byte)aSide) : isNormalCube(aWorld, aX, aY, aZ);}
    @Override public final boolean getWeakChanges(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityGetWeakChanges ? ((IMultiTileEntityGetWeakChanges)aTileEntity).getWeakChanges() : super.getWeakChanges(aWorld, aX, aY, aZ);}
	@Override public final boolean addHitEffects(World aWorld, MovingObjectPosition aTarget, EffectRenderer aRenderer) {TileEntity aTileEntity = aWorld.getTileEntity(aTarget.blockX, aTarget.blockY, aTarget.blockZ); return aTileEntity instanceof IMultiTileEntityAddHitEffects ? ((IMultiTileEntityAddHitEffects)aTileEntity).addHitEffects(aWorld, aTarget, aRenderer) : super.addHitEffects(aWorld, aTarget, aRenderer);}
    @Override public final boolean addDestroyEffects(World aWorld, int aX, int aY, int aZ, int aMetaData, EffectRenderer aRenderer) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityAddDestroyEffects ? ((IMultiTileEntityAddDestroyEffects)aTileEntity).addDestroyEffects(aMetaData, aRenderer) : super.addDestroyEffects(aWorld, aX, aY, aZ, aMetaData, aRenderer);}
    @Override public final int getMixedBrightnessForBlock(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityGetMixedBrightnessForBlock ? ((IMultiTileEntityGetMixedBrightnessForBlock)aTileEntity).getMixedBrightnessForBlock() : super.getMixedBrightnessForBlock(aWorld, aX, aY, aZ);}
    @Override public final boolean shouldSideBeRendered(IBlockAccess aWorld, int aX, int aY, int aZ, int aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityShouldSideBeRendered ? ((IMultiTileEntityShouldSideBeRendered)aTileEntity).shouldSideBeRendered((byte)aSide) : super.shouldSideBeRendered(aWorld, aX, aY, aZ, aSide);}
    @Override public final AxisAlignedBB getSelectedBoundingBoxFromPool(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityGetSelectedBoundingBoxFromPool ? ((IMultiTileEntityGetSelectedBoundingBoxFromPool)aTileEntity).getSelectedBoundingBoxFromPool() : super.getSelectedBoundingBoxFromPool(aWorld, aX, aY, aZ);}
    @Override public final void randomDisplayTick(World aWorld, int aX, int aY, int aZ, Random aRandom) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMultiTileEntityRandomDisplayTick) ((IMultiTileEntityRandomDisplayTick)aTileEntity).randomDisplayTick(aRandom); else super.randomDisplayTick(aWorld, aX, aY, aZ, aRandom);}
    @Override public final void onBlockExploded(World aWorld, int aX, int aY, int aZ, Explosion aExplosion) {if (aWorld.isRemote) return; TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof IMultiTileEntityOnBlockExploded) ((IMultiTileEntityOnBlockExploded)aTileEntity).onExploded(aExplosion); else aWorld.setBlockToAir(aX, aY, aZ);}
    @Override public final ItemStack getPickBlock(MovingObjectPosition aTarget, World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityGetPickBlock?((IMultiTileEntityGetPickBlock)aTileEntity).getPickBlock(aTarget):null;}
    @Override public final void breakBlock(World aWorld, int aX, int aY, int aZ, Block aBlock, int par6) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); sTemporaryTileEntity.set(aTileEntity); if (aTileEntity instanceof IMultiTileEntityBreakBlock) ((IMultiTileEntityBreakBlock)aTileEntity).breakBlock(); else aWorld.removeTileEntity(aX, aY, aZ);}
    @Override public final ItemStack getItemStackFromBlock(IBlockAccess aWorld, int aX, int aY, int aZ, byte aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityGetStackFromBlock?((IMultiTileEntityGetStackFromBlock)aTileEntity).getStackFromBlock(aSide):null;}
    @Override public final int getFlammability(IBlockAccess aWorld, int aX, int aY, int aZ, ForgeDirection aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityGetFlammability ? ((IMultiTileEntityGetFlammability)aTileEntity).getFlammability((byte)aSide.ordinal()) : 0;}
    @Override public final int getFireSpreadSpeed(IBlockAccess aWorld, int aX, int aY, int aZ, ForgeDirection aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityGetFireSpreadSpeed ? ((IMultiTileEntityGetFireSpreadSpeed)aTileEntity).getFireSpreadSpeed((byte)aSide.ordinal()) : 0;}
	@Override public final boolean isFireSource(World aWorld, int aX, int aY, int aZ, ForgeDirection aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityIsFireSource ? ((IMultiTileEntityIsFireSource)aTileEntity).isFireSource((byte)aSide.ordinal()) : false;}
	@Override public final boolean canEntityDestroy(IBlockAccess aWorld, int aX, int aY, int aZ, Entity aEntity) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityCanEntityDestroy ? ((IMultiTileEntityCanEntityDestroy)aTileEntity).canEntityDestroy(aEntity) : true;}
	@Override public final long onToolClick(String aTool, long aRemainingDurability, Entity aPlayer, IInventory aPlayerInventory, boolean aSneaking, ItemStack aStack, World aWorld, byte aSide, int aX, int aY, int aZ, float aHitX, float aHitY, float aHitZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityOnToolClick ? ((IMultiTileEntityOnToolClick)aTileEntity).onToolClick(aTool, aRemainingDurability, aPlayer, aPlayerInventory, aSneaking, aStack, aSide, aHitX, aHitY, aHitZ) : 0;}
	@Override public final OreDictMaterialStack getMaterialAtSide(IBlockAccess aWorld, int aX, int aY, int aZ, byte aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityGetMaterialAtSide?((IMultiTileEntityGetMaterialAtSide)aTileEntity).getMaterialAtSide(aSide):null;}
	@Override public final boolean removeMaterialFromSide(World aWorld, int aX, int aY, int aZ, byte aSide, OreDictMaterialStack aMaterial) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityRemoveMaterialFromSide ? ((IMultiTileEntityRemoveMaterialFromSide)aTileEntity).removeMaterialFromSide(aSide, aMaterial) : false;}
    @Override public final void dropBlockAsItemWithChance(World aWorld, int aX, int aY, int aZ, int aMeta, float aChance, int aFortune) {if (!aWorld.isRemote) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity == null) aTileEntity = sTemporaryTileEntity.get(); if (aTileEntity instanceof IMultiTileEntityGetDrops) {ArrayListNoNulls<ItemStack> tList = ((IMultiTileEntityGetDrops)aTileEntity).getDrops(aFortune, false); aChance = ForgeEventFactory.fireBlockHarvesting(tList, aWorld, this, aX, aY, aZ, aMeta, aFortune, aChance, false, harvesters.get()); for (ItemStack tStack : tList) if (aWorld.rand.nextFloat() <= aChance) dropBlockAsItem(aWorld, aX, aY, aZ, tStack);}}}
    @Override public final void harvestBlock(World aWorld, EntityPlayer aPlayer, int aX, int aY, int aZ, int aMeta) {aPlayer.addStat(StatList.mineBlockStatArray[getIdFromBlock(this)], 1); aPlayer.addExhaustion(0.025F); if (!aWorld.isRemote) {boolean aSilkTouch = EnchantmentHelper.getSilkTouchModifier(aPlayer); int aFortune = EnchantmentHelper.getFortuneModifier(aPlayer); float aChance = 1.0F; TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity == null) aTileEntity = sTemporaryTileEntity.get(); if (aTileEntity instanceof IMultiTileEntityGetDrops) {ArrayListNoNulls<ItemStack> tList = ((IMultiTileEntityGetDrops)aTileEntity).getDrops(aFortune, aSilkTouch); aChance = ForgeEventFactory.fireBlockHarvesting(tList, aWorld, this, aX, aY, aZ, aMeta, aFortune, aChance, aSilkTouch, harvesters.get()); for (ItemStack tStack : tList) if (aWorld.rand.nextFloat() <= aChance) dropBlockAsItem(aWorld, aX, aY, aZ, tStack);}}}
    @Override public final ArrayList<ItemStack> getDrops(World aWorld, int aX, int aY, int aZ, int aUnusableMetaData, int aFortune) {ArrayListNoNulls<ItemStack> tList = new ArrayListNoNulls<ItemStack>(); if (!aWorld.isRemote) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity == null) aTileEntity = sTemporaryTileEntity.get(); if (aTileEntity instanceof IMultiTileEntityGetDrops) tList = ((IMultiTileEntityGetDrops)aTileEntity).getDrops(aFortune, false);} return tList;}
    @Override public final float getPlayerRelativeBlockHardness(EntityPlayer aPlayer, World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityGetBlockHardness?Math.max(0.0F, ((IMultiTileEntityGetBlockHardness)aTileEntity).getBlockHardness(aPlayer)):1.0F;}
    @Override public final float getBlockHardness(World aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityGetBlockHardness?Math.max(0.0F, ((IMultiTileEntityGetBlockHardness)aTileEntity).getBlockHardness(null)):1.0F;}
    @Override public final float getExplosionResistance(Entity aExploder, World aWorld, int aX, int aY, int aZ, double aExplosionX, double aExplosionY, double aExplosionZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityGetExplosionResistance?Math.max(0.0F, ((IMultiTileEntityGetExplosionResistance)aTileEntity).getExplosionResistance(aExploder, aExplosionX, aExplosionY, aExplosionZ)):1.0F;}
    @Override public final boolean isSideSolid(IBlockAccess aWorld, int aX, int aY, int aZ, ForgeDirection aSide) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityIsSideSolid?((IMultiTileEntityIsSideSolid)aTileEntity).isSideSolid((byte)aSide.ordinal()):mOpaque;}
    @Override public final boolean isBeaconBase(IBlockAccess aWorld, int aX, int aY, int aZ, int aBeaconX, int aBeaconY, int aBeaconZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityIsBeaconBase?((IMultiTileEntityIsBeaconBase)aTileEntity).isBeaconBase(aBeaconX, aBeaconY, aBeaconZ):false;}
    @Override public final int getLightOpacity(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity instanceof IMultiTileEntityGetLightOpacity?((IMultiTileEntityGetLightOpacity)aTileEntity).getLightOpacity():mOpaque?255:0;}
	@Override public final boolean isOpaqueCube() {return mOpaque;}
	@Override public final boolean func_149730_j() {return mOpaque;}
	@Override public final boolean renderAsNormalBlock() {return mOpaque || mNormalCube;}
	@Override public final boolean isNormalCube()  {return mNormalCube;}
    @Override public final boolean canProvidePower() {return !mNormalCube;}
	@Override public final String getUnlocalizedName() {return mNameInternal;}
	@Override public final String getLocalizedName() {return StatCollector.translateToLocal(mNameInternal + ".name");}
	@Override public final String getHarvestTool(int aMaterialToolQuality) {return mTool;}
	@Override public final int getHarvestLevel(int aMaterialToolQuality) {return (int)UT.Code.bind(mHarvestLevelMinimum, mHarvestLevelMaximum, mHarvestLevelOffset + aMaterialToolQuality);}
	@Override public final boolean hasTileEntity(int aMeta) {return true;}
	@Override public final boolean canSilkHarvest() {return false;}
	@Override public final TileEntity createNewTileEntity(World aWorld, int aMeta) {return null;}
	@Override public final TileEntity createTileEntity(World aWorld, int aMeta) {return null;}
    @Override public final void getSubBlocks(Item aItem, CreativeTabs aCreativeTab, List aList) {/**/}
	@Override public final ITexture getTexture(int aRenderPass, byte aSide, short aMetaData) {return null;}
	@Override public final ITexture getTexture(int aRenderPass, byte aSide, IBlockAccess aWorld, int aX, int aY, int aZ) {return null;}
	@Override public final boolean setBlockBounds(int aRenderPass, byte aSide, short aMetaData) {return false;}
	@Override public final boolean setBlockBounds(int aRenderPass, byte aSide, IBlockAccess aWorld, int aX, int aY, int aZ) {return false;}
	@Override public final int getRenderPasses(byte aSide, short aMetaData) {return 0;}
	@Override public final int getRenderPasses(byte aSide, IBlockAccess aWorld, int aX, int aY, int aZ) {return 0;}
	@Override public final IRenderedBlockObject passRenderingToObject(short aMetaData) {return null;}
	@Override public final void registerBlockIcons(IIconRegister aIconRegister) {/**/}
    @Override public final IIcon getIcon(IBlockAccess aWorld, int aX, int aY, int aZ, int aSide) {return null;}
    @Override public final IIcon getIcon(int aSide, int aMetaData) {return null;}
	@Override public final int getRenderType() {return RendererBlockTextured.INSTANCE.mRenderID;}
	@Override public final IRenderedBlockObject passRenderingToObject(IBlockAccess aWorld, int aX, int aY, int aZ) {TileEntity tTileEntity = aWorld.getTileEntity(aX, aY, aZ); return tTileEntity instanceof IRenderedBlockObject ? (IRenderedBlockObject)tTileEntity : null;}
	@Override public final void onNeighborChange(IBlockAccess aWorld, int aX, int aY, int aZ, int aTileX, int aTileY, int aTileZ) {if (!LOCK) {LOCK = true; TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof ITileEntity) ((ITileEntity)aTileEntity).onAdjacentBlockChange(aTileX, aTileY, aTileZ); LOCK = false;}}
    @Override public final void onNeighborBlockChange(World aWorld, int aX, int aY, int aZ, Block aBlock) {if (!LOCK) {LOCK = true; TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); if (aTileEntity instanceof ITileEntity) ((ITileEntity)aTileEntity).onAdjacentBlockChange(aX, aY, aZ); LOCK = false;}}
    @Override public final boolean onBlockEventReceived(World aWorld, int aX, int aY, int aZ, int aID, int aData) {TileEntity aTileEntity = aWorld.getTileEntity(aX, aY, aZ); return aTileEntity == null || aTileEntity.receiveClientEvent(aID, aData);}
}