package gregapi.block.multitileentity;

import gregapi.block.multitileentity.MultiTileEntityInterfaces.IMultiTileEntityRegisterIcons;
import gregapi.render.IRenderedBlock;
import gregapi.render.IRenderedBlockObject;
import gregapi.render.ITexture;
import gregapi.render.RendererBlockTextured;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.client.renderer.texture.IIconRegister;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.IBlockAccess;
import cpw.mods.fml.common.registry.GameRegistry;

/**
 * @author Gregorius Techneticies
 */
public class MultiTileEntityBlockInternal extends Block implements IRenderedBlock {
	public final MultiTileEntityRegistry mMultiTileEntityRegistry;
	
	public MultiTileEntityBlockInternal(MultiTileEntityRegistry aMultiTileEntityRegistry) {
		super(Material.anvil);
		mMultiTileEntityRegistry = aMultiTileEntityRegistry;
		GameRegistry.registerBlock(this, MultiTileEntityItemInternal.class, mMultiTileEntityRegistry.mNameInternal);
	}
	
	@Override public ITexture getTexture(int aRenderPass, byte aSide, short aMetaData) {return null;}
	@Override public ITexture getTexture(int aRenderPass, byte aSide, IBlockAccess aWorld, int aX, int aY, int aZ) {return null;}
	@Override public boolean setBlockBounds(int aRenderPass, byte aSide, short aMetaData) {return false;}
	@Override public boolean setBlockBounds(int aRenderPass, byte aSide, IBlockAccess aWorld, int aX, int aY, int aZ) {return false;}
	@Override public int getRenderPasses(byte aSide, short aMetaData) {return 0;}
	@Override public int getRenderPasses(byte aSide, IBlockAccess aWorld, int aX, int aY, int aZ) {return 0;}
	
	@Override
	public IRenderedBlockObject passRenderingToObject(short aMetaData) {
		TileEntity tTileEntity = mMultiTileEntityRegistry.getNewTileEntity(new ItemStack(this, 1, aMetaData));
		return tTileEntity instanceof IRenderedBlockObject ? (IRenderedBlockObject)tTileEntity : null;
	}
	
	@Override
	public IRenderedBlockObject passRenderingToObject(IBlockAccess aWorld, int aX, int aY, int aZ) {
		return null;
	}
	
	@Override
	public int getRenderType() {
		return RendererBlockTextured.INSTANCE == null ? super.getRenderType() : RendererBlockTextured.INSTANCE.mRenderID;
	}
	
	@Override
	public void registerBlockIcons(IIconRegister aIconRegister) {
		for (MultiTileEntityClassContainer tClassContainer : mMultiTileEntityRegistry.mRegistry.values()) if (tClassContainer.mTileEntity instanceof IMultiTileEntityRegisterIcons) ((IMultiTileEntityRegisterIcons)tClassContainer.mTileEntity).registerIcons(aIconRegister);
	}
}