package gregapi.block.multitileentity;

import gregapi.util.UT;
import net.minecraft.block.Block.SoundType;
import net.minecraft.block.material.Material;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;

/**
 * @author Gregorius Techneticies
 */
public class MultiTileEntityClassContainer {
	public final Class<? extends TileEntity> mClass;
	public final MultiTileEntityBlock mBlock;
	public final TileEntity mTileEntity;
	public final NBTTagCompound mParameters;
	public final byte mBlockMetaData, mStackSize;
	
	public MultiTileEntityClassContainer(Class<? extends TileEntity> aClass, int aBlockMetaData, int aStackSize, MultiTileEntityBlock aBlock, NBTTagCompound aParameters) {
		mBlockMetaData = (byte)aBlockMetaData;
		mStackSize = (byte)aStackSize;
		mParameters = aParameters;
		mBlock = aBlock;
		mClass = aClass;
		mTileEntity = (TileEntity)UT.Reflection.callConstructor(mClass, -1, null, true);
		if (mTileEntity != null) mTileEntity.readFromNBT(mParameters);
	}
	
	public MultiTileEntityClassContainer(Class<? extends TileEntity> aClass, int aBlockMetaData, int aStackSize, String aNameOfVanillaMaterialField, Material aVanillaMaterial, SoundType aSoundType, String aTool, int aHarvestLevelOffset, int aHarvestLevelMinimum, int aHarvestLevelMaximum, boolean aOpaque, boolean aNormalCube, NBTTagCompound aParameters) {
		this(aClass, aBlockMetaData, aStackSize, MultiTileEntityBlock.getOrCreate(aNameOfVanillaMaterialField, aVanillaMaterial, aSoundType, aTool, aHarvestLevelOffset, aHarvestLevelMinimum, aHarvestLevelMaximum, aOpaque, aNormalCube), aParameters);
	}
}
